=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2005-10-14 09:37:21 +0000
+++ bzrlib/builtins.py	2005-10-14 09:42:49 +0000
@@ -717,7 +717,7 @@
             short=False):
         from bzrlib.log import log_formatter, show_log
         import codecs
-        assert isinstance(message, basestring), \
+        assert message is None or isinstance(message, basestring), \
             "invalid message argument %r" % message
         direction = (forward and 'forward') or 'reverse'
         

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2005-10-14 09:37:21 +0000
+++ bzrlib/commands.py	2005-10-14 09:42:49 +0000
@@ -276,7 +276,7 @@
     lookup table, something about the available options, what optargs
     they take, and which commands will accept them.
     """
-    # TODO: chop up this beast
+    # TODO: chop up this beast; make it a method of the Command
     args = []
     opts = {}
 
@@ -284,15 +284,18 @@
     argsover = False
     while argv:
         a = argv.pop(0)
-        if not argsover and a[0] == '-':
+        if argsover:
+            args.append(a)
+            continue
+        elif a == '--':
+            # We've received a standalone -- No more flags
+            argsover = True
+            continue
+        if a[0] == '-':
             # option names must not be unicode
             a = str(a)
             optarg = None
             if a[1] == '-':
-                if a == '--':
-                    # We've received a standalone -- No more flags
-                    argsover = True
-                    continue
                 mutter("  got option %r" % a)
                 if '=' in a:
                     optname, optarg = a[2:].split('=', 1)

=== modified file 'bzrlib/selftest/testoptions.py'
--- bzrlib/selftest/testoptions.py	2005-10-14 09:37:21 +0000
+++ bzrlib/selftest/testoptions.py	2005-10-14 09:42:49 +0000
@@ -20,6 +20,11 @@
         ## eq(parse_args(cmd_log(),  '-r 500'.split()),
         ##   ([], {'revision': RevisionSpec_int(500)}))
 
+    def test_no_more_opts(self):
+        """Terminated options"""
+        self.assertEquals(parse_args(cmd_commit(), ['--', '-file-with-dashes']),
+                          (['-file-with-dashes'], {}))
+
     def test_option_help(self):
         """Options have help strings."""
         out, err = self.run_bzr_captured(['commit', '--help'])

